Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 1061412 - [RFE] Private keys encrypted with AES are unsupported
Summary: [RFE] Private keys encrypted with AES are unsupported
Keywords:
Status: CLOSED WONTFIX
Alias: None
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: nss
Version: 7.1
Hardware: Unspecified
OS: Unspecified
low
low
Target Milestone: rc
: ---
Assignee: Elio Maldonado Batiz
QA Contact: BaseOS QE Security Team
URL:
Whiteboard:
Depends On:
Blocks: 1295396
TreeView+ depends on / blocked
 
Reported: 2014-02-04 19:31 UTC by Hubert Kario
Modified: 2017-01-04 11:54 UTC (History)
5 users (show)

Fixed In Version:
Doc Type: Enhancement
Doc Text:
Clone Of:
Environment:
Last Closed: 2016-01-25 14:55:47 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Bugzilla 1051533 None CLOSED curl unable to load openssl encrypted private key 2019-02-20 09:39:27 UTC

Internal Links: 1051533

Description Hubert Kario 2014-02-04 19:31:06 UTC
Description of problem:
When the private key is placed in encrypted pem file, curl is unable to decrypt it and ends connection with NSS error -8178.

Version-Release number of selected component (if applicable):
nss-3.15.3-6.el6_5.x86_64
curl-7.19.7-37.el6_4.x86_64
openssl-1.0.1e-15.el6.x86_64

How reproducible:
always

Steps to Reproduce:
1. Generate key pair
2. Encrypt private key using `openssl rsa -aes128`
3. run curl with private key created in step 2

Actual results:
:: [ 19:24:57 ] :: [ INFO    ] :: The expected error value if the bug is not fixed is "-12205"
* About to connect() to localhost port 21 (#0)
*   Trying ::1... Connection refused
*   Trying 127.0.0.1... connected
* Connected to localhost (127.0.0.1) port 21 (#0)
< 220 (vsFTPd 2.2.2)
> AUTH SSL
< 234 Proceed with negotiation.
* Initializing NSS with certpath: sql:/etc/pki/nssdb
*   CAfile: /etc/pki/CA/certs/ca_cert.pem
  CApath: none
* Unable to load client key -8178.
* NSS error -8178
* Closing connection #0

curl: (58) Unable to load client key -8178.

Expected results:
Connection established with client cert authentication

Additional info:

Private key is and encrypted PKCS#8 file, so it's not a duplicate of bug 1051533.

That is, the file starts with:
-----BEGIN RSA PRIVATE KEY-----
Proc-Type: 4,ENCRYPTED
DEK-Info: AES-128-CBC,10CCFF835EC0173E4A90BE87AFA90806

Comment 1 Rob Crittenden 2014-02-05 15:15:47 UTC
In RHEL 6 pemnss doesn't support this type of key at all. It is unrelated to the encryption scheme.

Support was added upstream but apparently not backported, http://fedorapeople.org/cgit/rcritten/public_git/pemnss.git/commit/?id=030f9ff85ec40167b5d885c980a44c090e5729d6

Comment 2 Rob Crittenden 2014-02-05 15:17:57 UTC
Ah, nm, I misread the patch.

Comment 3 Nathan Kinder 2015-10-07 18:58:10 UTC
We have no plans to add this feature in RHEL 6.x, as we have no customer request for it.  Pushing this to RHEL 7.x.

Comment 4 Elio Maldonado Batiz 2016-01-18 15:13:06 UTC
This is a PEM module bug so Kai and I need need to get together on this as there has done some work on cleaning up the PEM module done in the temporary upstream  for PEM. We must coordinate. I consider this bug low priority.

Comment 6 Christopher Tubbs 2017-01-03 17:24:16 UTC
This bug is high priority for users who depend heavily on PKI. AES would be strongly preferable to DES3. This seems to be a regression from the user's perspective (although it's probably the result of a newer version of curl using nss instead of openssl, rather than a regression in nss).

This bug is closed as "WONTFIX", but there's no explanation why it won't be fixed. It appears to still affect 7.3.

Comment 8 Nikos Mavrogiannopoulos 2017-01-04 11:54:27 UTC
    Thank you for taking the time to enter a bug report with us. We appreciate the feedback and look to use reports such as this to guide our efforts at improving our products. That being said, this bug tracking system is not a mechanism for requesting support, and we are not able to  guarantee the timeliness or suitability of a resolution.

    If this issue is critical or in any way time sensitive, please raise a ticket through your regular Red Hat support channels to make certain  it receives the proper attention and prioritization to assure a timely resolution. 

    For information on how to contact the Red Hat production support team, please visit:

    https://access.redhat.com/support/


Note You need to log in before you can comment on or make changes to this bug.